﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.IO;
using System.Windows.Media.Effects;
using Sheva.Windows.Effects;

namespace ShaderEffectDemo
{
    public partial class NoParameterShaderPage : Page
    {
        public NoParameterShaderPage()
        {
            InitializeComponent();
            comboBox.SelectionChanged += delegate
            {
                switch (comboBox.SelectedValue.ToString())
                {
                    case "Invert":
                        image.Effect = CreateSourceShaderEffect("Invert");
                        break;
                    case "Grayscale":
                        image.Effect = CreateSourceShaderEffect("Grayscale");
                        break;
                    case "Sepia":
                        image.Effect = CreateSourceShaderEffect("Sepia");
                        break;
                    case "None":
                    default:
                        this.image.Effect = null;
                        break;
                }
            };
        }

        public static ShaderEffect CreateSourceShaderEffect(String shaderLocation)
        {
            ShaderEffect effect = null;
            shaderLocation = "pack://application:,,,/Shaders/" + shaderLocation + ".fx";
            Stream shaderStream = Application.GetResourceStream(new Uri(shaderLocation, UriKind.Absolute)).Stream;
            if (null != shaderStream)
            {
                effect = new SourceShaderEffect(shaderStream);
            }

            return effect;
        }
    }
}
